#ifdef _WIN32
#  define LL "%I64d"
#else
#  define LL "%Ld"
#endif

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cstring>
#include <ctime>
#include <vector>
#include <deque>
#include <set>
#include <map>
#include <queue>
#include <stack>
#include <bitset>
#include <string>
#include <algorithm>
#include <complex>
#include <utility>
#include <cassert>
using namespace std;
#define null NULL
#define mp make_pair
#define pb(a) push_back(a)
#define sz(a) ((int)(a).size())
#define all(a) a.begin() , a.end()
#define fi first
#define se second
#define relaxMin(a , b) (a) = min((a),(b))
#define relaxMax(a , b) (a) = max((a),(b))
#define SQR(a) ((a)*(a))
typedef vector<int> vi;
typedef pair<int,int> pii;
typedef long long ll;
#define MAX 10010
#define MAXS 110
#define LAST 1152921504606846976LL
// Timing
#define TL 4.7
#define MIDDLE 2.5
void quit();
double BEG = clock();
void check_time(){
  if(clock() - BEG > TL * CLOCKS_PER_SEC)
   quit();
}
// Storing candidates
vector< vi > cand;
vi give;
#define MAX_SZ 5
bool cmp_cand(const int& f , const int& s){
  return give[f] > give[s];
}
void update_best(bool always = false){
  if(!always && sz(cand) < 2*MAX_SZ) return;
  vi id(sz(cand));
  for(int i=0;i<sz(cand);++i)
   id[i] = i;
  sort(all(id) , cmp_cand);
  vector< vi > ncand;
  vi ngive;
  int UP = min(MAX_SZ , sz(cand));
  for(int i=0;i<UP;++i)
   ncand.pb(vi()) , ngive.pb(give[id[i]]),
   ncand[i].swap(cand[id[i]]);
  cand.swap(ncand);
  give.swap(ngive);
}
// Windows
FILE *rfile , *wfile;
int wh[MAX] , ww[MAX] , wtop[MAX][MAXS];
ll wmap[MAX][MAXS][2];
bool w_cmp(const int& f , const int& s){
  return wh[f] * ww[f] > wh[s] * ww[s];
}
void read_window(int id){
  fscanf(rfile , "%d%d" , &wh[id] , &ww[id]);
}
// Shapes
double score[MAX];
int sh[MAX] , sw[MAX] , spr[MAX] , spcs[MAX];
int max_down[MAX][MAXS];
ll smap[MAX][MAXS][2];
bool s_cmp(const int& f , const int& s){
  return score[f] > score[s];
}
void read_shape(int id){
  fscanf(rfile , "%d%d%d" , &sh[id] , &sw[id] , &spr[id]);
  for(int i=0;i<sh[id];++i)
   for(int j=0;j<sw[id];++j){
    int val; fscanf(rfile , "%d" , &val);
    if(val){
     relaxMax(max_down[id][j] , i);
     ++spcs[id];
     if(j < 60)smap[id][i][0] |= (1LL<<j);
     else smap[id][i][1] |= (1LL<<(j-60));
           }
                            }
}
// Input
int N , M;
void read(){
  rfile = fopen("decoration.in" , "r");
  fscanf(rfile , "%d%d" , &N , &M);
  for(int i=0;i<N;++i) read_window(i);
  for(int i=0;i<M;++i) read_shape(i);
  fclose(rfile);
}
// Operations
void clear_all(){
  for(int i=0;i<N;++i){
   for(int j=0;j<wh[i];++j)
    wmap[i][j][0] = wmap[i][j][1] = 0;
   for(int j=0;j<ww[i];++j)
    wtop[i][j] = 0;
                      }
}
ll sbuf[MAXS][2];
void put(int s , int w , int x , int y){
  for(int i=0;i<sh[s];++i){
   sbuf[i][0] = smap[s][i][0];
   sbuf[i][1] = smap[s][i][1];
   for(int j=0;j<y;++j){
    sbuf[i][0] <<= 1 , sbuf[i][1] <<= 1;
    if(sbuf[i][0] & LAST)
     sbuf[i][0] ^= LAST,
     ++sbuf[i][1];
                       }
                          }
  for(int i=0;i<sh[s];++i)
   wmap[w][x+i][0] ^= sbuf[i][0],
   wmap[w][x+i][1] ^= sbuf[i][1];
}
int FUNC_SCORE;
pii get_best(int w , int s){
  int bdlt = 1000000000;
  int bx = -1 , by = -1 , SS = sh[s];
  ll* cwmap = &(wmap[w][0][0]);
  for(int i=0;i<sh[s];++i)
   sbuf[i][0] = smap[s][i][0],
   sbuf[i][1] = smap[s][i][1];
  for(int y=0;y+sw[s]<=ww[w];++y){
   for(int x=0;x+sh[s]<=wh[w];++x){
    bool fine = true;
    // Check intersection
    for(int i=0;i<SS;++i)
     if((sbuf[i][0] & cwmap[(x + i)<<1]) ||
        (sbuf[i][1] & cwmap[((x + i)<<1)+1])){
      fine = false;
      break;
                                            }
    // </end>
    if(fine){
     int cdlt = 0;
     for(int j=0;j<sw[s];++j)
      if(wtop[w][y+j] < x + max_down[s][j])
       cdlt += x + max_down[s][j] - wtop[w][y+j];
     if(cdlt < bdlt)
      bdlt = cdlt , bx = x , by = y;
     break;
            }
                                  }
   // Shift one
   for(int i=0;i<SS;++i){
    sbuf[i][0] <<= 1 , sbuf[i][1] <<= 1;
    if(sbuf[i][0] & LAST)
     sbuf[i][0] ^= LAST,
     ++sbuf[i][1];
                        }
   // </end>
                                 }
  FUNC_SCORE = bdlt;
  return mp(bx , by);
}
// Solution
int w_order[MAX] , s_order[MAX] , cpy_s_order[MAX];
int sol_w[MAX] , sol_x[MAX] , sol_y[MAX];
void find_pos(int shp , int& pw , int& px , int& py , int& cost){
  pw = px = py = -2;
  cost = 1000000;
  for(int j=0;j<N;++j){
   check_time();
   pii tmp = get_best(w_order[j] , shp);
   if(tmp.fi != -1){
    cost = FUNC_SCORE;
    pw = w_order[j] , px = tmp.fi , py = tmp.se;
    return;
                   }
                      }
}
void put_to_pos(int shp , int pw , int px , int py){
  if(pw >= 0) put(shp , pw , px , py);
}
void add_to_ans(int shp , int pw , int px , int py){
  sol_w[shp] = pw + 1;
  sol_x[shp] = px + 1;
  sol_y[shp] = py + 1;
}
void place(){
  for(int i=0;i<M;++i){
   int pw = -2 , px = -2 , py = -2 , scr;
   find_pos(s_order[i] , pw , px , py , scr);
   add_to_ans(s_order[i] , pw , px , py);
   put_to_pos(s_order[i] , pw , px , py);
                      }
}
ll solution_val(){
  vector<ll> w_in(N , 0);
  vector<ll> w_cnt(N , 0);
  for(int i=0;i<M;++i)
   if(sol_w[i] != -1)
    w_in[sol_w[i] - 1] += spr[i],
    ++w_cnt[sol_w[i] - 1];
  ll cost = 0;
  for(int i=0;i<N;++i)
   cost += w_cnt[i] * w_in[i];
  return cost;
}
ll bst_cost = -1000000;
int bst_w[MAX] , bst_x[MAX] , bst_y[MAX];
ll update(){
  ll cost = solution_val();
  if(cost > bst_cost)
   for(int i=0;i<M;++i)
    bst_cost = cost,
    bst_w[i] = sol_w[i],
    bst_x[i] = sol_x[i],
    bst_y[i] = sol_y[i];
  return cost;
}
ll solve_once(bool to_set){
  clear_all();
  place();
  int val = update();
  if(to_set){
   give.pb(val);
   cand.pb(vi(s_order , s_order + M));
   update_best();
            }
  return val;
}
int ITERS = 0;
void solve(int LIM = 80 , bool to_set = true){
  ll prev_score = -1000000;
  while(true){
   ll begin = prev_score;
   for(int i=0;i<LIM;++i){
    ++ITERS;
    int a = rand() % M,
        b = rand() % M;
    swap(s_order[a] , s_order[b]);
    ll cur = solve_once(to_set);
    if(cur < prev_score)
     swap(s_order[a] , s_order[b]);
    else prev_score = cur;
                        }
   //cout<<begin<<' '<<prev_score<<endl;
   if(begin >= prev_score)break;
             }
  //cout<<prev_score<<endl;
}
// Output
void out_w(int w){
  cout<<"!"<<wh[w]<<' '<<ww[w]<<endl;
  for(int i=0;i<wh[w];++i){
   for(int j=0;j<ww[w];++j){
    if(j < 60) printf("%c" , (wmap[w][i][0]&(1LL<<j))?'1':'0');
    else printf("%c" , (wmap[w][i][1]&(1LL<<(j-60)))?'1':'0');
                           }
   puts("");
                          }
}
void print_solution(){
  wfile = fopen("decoration.out" , "w");
  for(int i=0;i<M;++i)
   fprintf(wfile , "%d %d %d\n" , bst_w[i] , bst_x[i] , bst_y[i]);
  fclose(wfile);
}
void quit(){
  //cout<<ITERS<<endl;
  cout<<bst_cost<<'\n';
  //for(int i=0;i<N;++i) out_w(i);
  print_solution();
  exit(0);
}
int main(){
  srand(13331);
  read();
  for(int i=0;i<N;++i) w_order[i] = i;
  for(int i=0;i<M;++i) s_order[i] = i;
  sort(w_order , w_order + N , w_cmp);
  double max_pcs = *max_element(spcs , spcs + M),
         max_pr = *max_element(spr , spr + M);
  for(int i=0;i<M;++i)
   score[i] = spcs[i]/max_pcs + spr[i]/max_pr;
  sort(s_order , s_order + M , s_cmp);
  solve();
  for(int i=0;i<M;++i)
   score[i] = spr[i];
  sort(s_order , s_order + M , s_cmp);
  solve();
  for(int i=0;i<M;++i)
   score[i] = -spcs[i];
  sort(s_order , s_order + M , s_cmp);
  solve();
  for(;;){
   solve();
   if(clock() - BEG > MIDDLE * CLOCKS_PER_SEC)
    break;
   random_shuffle(s_order , s_order + M);
         }
  update_best(true);
  for(;;){
   for(int i=0;i<sz(cand);++i){
    for(int j=0;j<sz(cand[i]);++j)
     s_order[j] = cand[i][j];
    solve(120 , false);
    for(int j=0;j<sz(cand[i]);++j)
     cand[i][j] = s_order[j];
                              }
         }
  quit();
  return 0;
}
